
local lg=love.graphics

local offsetY = -100
local spreadY = 100
function love.load()
	ps = {}
	lg.setBlendMode( "add" )
	particle_img = lg.newImage("default_particle.png")
	particle_width = particle_img:getWidth()
	ps0 = lg.newParticleSystem(particle_img,200)
	ps0:setColors(
		100, 150, 255, 0, 
		100, 150, 255, 200, 
		255, 70, 30, 100,
		255, 0, 0, 0 
	)
	ps0:setSizes(1)
	ps0:setParticleLifetime(1)
	ps0:setOffset( 0, offsetY )
	ps0:setAreaSpread( "uniform", 0, spreadY )
	ps0:setEmissionRate(100)
	ps0:start()
	table.insert(ps,ps0)

	table.insert(ps,ps0:clone())
	ps[#ps]:setSizes(0.7)

	table.insert(ps,ps0:clone())
	ps[#ps]:setSizes(0.5)

	table.insert(ps,ps0:clone())
	ps[#ps]:setSizes(0.3)

	table.insert(ps,ps0:clone())
	ps[#ps]:setSizes(0.3,1)

	table.insert(ps,ps0:clone())
	ps[#ps]:setSizes(0.3,1,0.3)

	table.insert(ps,ps0:clone())
	ps[#ps]:setSizes(1,0.3)
end


function love.update(dt)
	for k,v in pairs(ps) do v:update(dt) end
end

function love.draw()
	local drawX,drawY=150,350
	for k,v in pairs(ps) do
		lg.setColor(255,255,255,255)
		lg.draw(v,drawX,drawY)
		lg.setColor(255,0,0,255)
		lg.rectangle("line", drawX-5, drawY-spreadY-offsetY, particle_width+10, spreadY*2)
		local _={v:getSizes()}
		for i,v in ipairs(_) do _[i]=string.format("%0.2f",v) end
		lg.print("sizes:\n"..table.concat( _,"\n"),drawX,20+drawY+spreadY*2)
		drawX = drawX+100
	end
end

return dlp
